// 
// Decompiled by Procyon v0.5.36
// 

package com.justinmind.generatejquerymobile.handlers;

import com.justinmind.generatejquerymobile.Screen;
import com.justinmind.generatejquerymobile.ComponentFactory;
import com.justinmind.generatejquerymobile.Component;
import com.justinmind.prototyper.api.ui.component.ICanvasComponent;
import com.justinmind.generatejquerymobile.APIUtilities;
import java.util.LinkedList;
import org.stringtemplate.v4.ST;
import org.stringtemplate.v4.STGroup;
import java.util.Iterator;
import java.util.List;
import java.io.InputStream;
import com.justinmind.prototyper.api.IPrototype;
import java.io.IOException;
import java.awt.Desktop;
import org.stringtemplate.v4.STWriter;
import org.stringtemplate.v4.AutoIndentWriter;
import java.io.Writer;
import java.net.URL;
import java.io.BufferedWriter;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.FileOutputStream;
import org.stringtemplate.v4.STGroupFile;
import com.justinmind.prototyper.api.ui.canvas.IScreen;
import java.io.File;
import javafx.stage.Window;
import javafx.stage.DirectoryChooser;
import com.justinmind.prototyper.api.API;
import com.justinmind.prototyper.api.plugins.IPlugin;

public class JQueryMobileHandler implements IPlugin
{
    public void run() {
        this.generateJQueryCode();
    }
    
    protected void generateJQueryCode() {
        BufferedWriter writer = null;
        try {
            final IPrototype prototype = API.getPrototypeLoader().loadPrototype();
            if (prototype == null) {
                return;
            }
            final DirectoryChooser dialog = new DirectoryChooser();
            final File destination_folder = dialog.showDialog((Window)null);
            if (destination_folder == null) {
                return;
            }
            final InputStream input_stream = this.getClass().getResourceAsStream("resources/app_skeleton.zip");
            this.copyFileToFolder(input_stream, destination_folder + File.separator + "app_skeleton.zip");
            FileUtils.unZip(destination_folder + File.separator + "app_skeleton.zip", destination_folder.getAbsolutePath());
            final List<IScreen> screens = (List<IScreen>)prototype.getApiScreens();
            for (final IScreen screen : screens) {
                final String groupURL = "resources/Screen.stg";
                URL group = this.getClass().getResource(groupURL);
                final STGroup stGroup = (STGroup)new STGroupFile(group, "UTF-8",'$', '$');
                final ST page = stGroup.getInstanceOf("Page");
                page.add("header", (Object)screen.getApiName());
                page.add("footer", (Object)screen.getApiName());
                page.add("screencontent", this.getScreenContent(screen));
                final File file = new File(destination_folder + File.separator + "app" + File.separator + screen.getApiName() + ".html");
                if (!file.exists()) {
                    FileUtils.deepCreateFile(file);
                }
                writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file, false), "UTF-8"));
                page.write((STWriter)new AutoIndentWriter((Writer)writer));
                writer.flush();
            }
            Desktop.getDesktop().open(new File(destination_folder + File.separator + "app"));
        }
        catch (Exception e) {
            e.printStackTrace();
            if (writer != null) {
                try {
                    writer.close();
                }
                catch (IOException e2) {
                    e2.printStackTrace();
                }
            }
            return;
        }
        finally {
            if (writer != null) {
                try {
                    writer.close();
                }
                catch (IOException e2) {
                    e2.printStackTrace();
                }
            }
        }
        if (writer != null) {
            try {
                writer.close();
            }
            catch (IOException e2) {
                e2.printStackTrace();
            }
        }
    }
    
    private Object getScreenContent(final IScreen screen) {
        final List<String> jquery_mobile_components = new LinkedList<String>();
        jquery_mobile_components.add("NavBar");
        jquery_mobile_components.add("BasicList");
        jquery_mobile_components.add("Button");
        jquery_mobile_components.add("Input Label");
        jquery_mobile_components.add("Input Text");
        jquery_mobile_components.add("Textarea");
        jquery_mobile_components.add("Search");
        jquery_mobile_components.add("Flip Switch");
        jquery_mobile_components.add("Slider");
        jquery_mobile_components.add("Check box group");
        jquery_mobile_components.add("Radio choice");
        jquery_mobile_components.add("Select list");
        jquery_mobile_components.add("Paragraph");
        jquery_mobile_components.add("H1");
        jquery_mobile_components.add("H2");
        jquery_mobile_components.add("H3");
        jquery_mobile_components.add("HTML injection");
        final ICanvasComponent body_component = APIUtilities.findFirstOccurrenceComponent("Body", (ICanvasComponent)screen.getApiRoot());
        if (body_component == null) {
            return null;
        }
        final List<ICanvasComponent> components = APIUtilities.findComponents(jquery_mobile_components, body_component);
        final List<Component> component_models = new LinkedList<Component>();
        for (final ICanvasComponent current : components) {
            component_models.add(ComponentFactory.getComponentModel(current));
        }
        final Screen screen_model = new Screen(component_models);
        return screen_model;
    }
    
    private void copyFileToFolder(final InputStream input_stream, final String file) throws Exception {
        final OutputStream out = new FileOutputStream(new File(file));
        int read = 0;
        final byte[] bytes = new byte[1024];
        while ((read = input_stream.read(bytes)) != -1) {
            out.write(bytes, 0, read);
        }
        input_stream.close();
        out.flush();
        out.close();
    }
    
    public String getName() {
        return "Generate JQuery Mobile code";
    }
}
